; JustRecently - Recent Files Browser
#NoEnv
#SingleInstance Force ;change to ignore
#Include includes\Anchor.ahk ; Thanks to Titan for their Anchoring & functions tools http://www.autohotkey.net/~Titan/
#Include includes\Functions.ahk
#Include shared\svd-shared.ahk ;shared includes

FileCreateDir, dcuhelper
FileInstall, dcuhelper\dcuhelper.exe, dcuhelper\dcuhelper.exe, 1
FileInstall, svd-justclosesometasks.dcupdate, svd-justclosesometasks.dcupdate, 1
FileInstall, readme.txt, readme.txt, 1

SendMode Input
SetTitleMatchMode, 2  ; Avoids the need to specify the full path of the file below.
SetTitleMatchMode, RegEx 
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

functions()

SysGet,monitors,MonitorCount
Loop,% monitors
{
  current:=A_Index
  SysGet,monitor,Monitor,%current%
  If (mx>=monitorLeft And mx<=monitorRight And my>=monitorTop and my<=monitorBottom)
    Break
}
current+=1
If (current>monitors)
  current=1
SysGet,monitor,Monitor,%current%
;msgbox,%current%`n%monitors%


;vars	
TimerInterval = 1000
IniFile = settings.ini
AppTitle = JustCloseSomeTasks - Close Inactive Tasks
ExcludedTitlesRegEx := "i)Start|Start Menu|Program Manager"

;ini
IniRead, Hotkey1, %IniFile%, Main, Hotkey1, ^[
IniRead, RunAtStartup, %IniFile%, Main, RunAtStartup, 0
IniRead, AlwaysOnTop, %IniFile%, Main, AlwaysOnTop, 0
IniRead, HideExcludedProcesses, %IniFile%, Whitelist, HideExcludedProcesses, 1
IniRead, ExcludedProcessesPerm, %IniFile%, Whitelist, ExcludedProcessesPerm,%A_Space%
IniRead, ExcludedTitlesPerm, %IniFile%, Whitelist, ExcludedTitlesPerm,%A_Space%
IniRead, TotalClosedTasks, %IniFile%, Stats, TotalClosedTasks, 20
IniRead, TotalClosedSeconds, %IniFile%, Stats, TotalClosedSeconds, 7200
IfNotExist, %IniFile%
	GoSub, WriteIni

; gui menubar
Menu, FileMenu, Add, &Stats, MenuStats
Menu, FileMenu, Add,
Menu, FileMenu, Add, &Hide, MenuHide
Menu, FileMenu, Add, E&xit `tAlt-F4, MenuExit
Menu, ViewMenu, Add, &Hide Excluded Processes, MenuHideExcluded
Menu, ViewMenu, Add, Always on &Top, MenuAlwaysOnTop
Menu, HelpMenu, Add, &About... `tF1, MenuAbout
Menu, HelpMenu, Add, &Support, MenuOnline
Menu, HelpMenu, Add, &Homepage, MenuHomepage
Menu, HelpMenu, Add,
Menu, HelpMenu, Add, &Check for Updates, CheckForUpdates	
Menu, MyMenuBar, Add, &File, :FileMenu 
Menu, MyMenuBar, Add, &View, :ViewMenu 
Menu, MyMenuBar, Add, &Help, :HelpMenu
If HideExcludedProcesses = 1
	Menu,ViewMenu,Check,&Hide Excluded Processes
If AlwaysOnTop = 1
		Menu,ViewMenu,Check,Always on &Top

; right click menu
Menu,OptionsExclude,Add,Switch To,SwitchTo
Menu,OptionsExclude,Add,Minimize,MinimizeTask
Menu,OptionsExclude,Add,Maximize,MaximizeTask
Menu,OptionsExclude,Add,Info,TaskInfo
Menu,OptionsExclude,Add,
Menu,OptionsExclude,Add,Exclude Process This Session,ExcludeProcessTemp
Menu,OptionsExclude,Add,Exclude Process Permanently,ExcludeProcessPerm
Menu,OptionsExclude,Add,Exclude Title This Session,ExcludeTitleTemp
Menu,OptionsExclude,Add,Exclude Title Permanently,ExcludeTitlePerm
Menu,OptionsExclude,Add,
Menu,OptionsExclude,Add,Bring To Front,BringToFront
Menu,OptionsExclude,Add,Send To Back,SendToBack
Menu,OptionsExclude,Add,
Menu,OptionsExclude,Add,Close,ExitTask

Menu,OptionsInclude,Add,Switch To,SwitchTo
Menu,OptionsInclude,Add,Minimize,MinimizeTask
Menu,OptionsInclude,Add,Maximize,MaximizeTask
Menu,OptionsInclude,Add,Info,TaskInfo
Menu,OptionsInclude,Add,
Menu,OptionsInclude,Add,Remove from exclusion list,RemoveExclusion
Menu,OptionsInclude,Add,
Menu,OptionsInclude,Add,Bring To Front,BringToFront
Menu,OptionsInclude,Add,Send To Back,SendToBack
Menu,OptionsInclude,Add,
Menu,OptionsInclude,Add,Close,ExitTask

;training
GoSub, CalcExpiryTime

; GuiPreferences
Gui, 1:Default
Gui, +Resize
Gui +OwnDialogs 
Gui, Menu, MyMenuBar
Gui, Add, Text,Section,Tasks found:
Gui, Add, ListView, r20 Count20 w610 Checked AltSubmit gMyListView vMyListView, Task|Id|Last Active (s)
Gui, Add, Text,Section vExpiryText w600, Tasks inactive for over %ExpiryTime% Seconds are checked
Gui, Add, Button, Section vSubmit gButtonSubmit Default, &Close Tasks

; GuiCloseInactiveTasks
Gui, 2:Default ;prefs
Gui, -Resize
Gui +OwnDialogs 
Gui, Menu, MyMenuBar
Gui, Add, Text,Section, Close inactive tasks hotkey:
Gui, Add, Hotkey, ys x180 vHotKey1 , %HotKey1%  
Gui, Add, Text,xs Section, Tasks are marked for closure after:
Gui, Add, Edit, ys x180 vExpiryTime w50, %ExpiryTime%  
Gui, Add, UpDown, vMyUpDown Range1-10000, %ExpiryTime%  

Gui, Add, Text,ys, seconds
Gui, Add, Checkbox, vRunAtStartup xs Section, Run at startup
Gui, Add, Text, xs Section,
Gui, Add, Button, xs Section GGuiPreferencesResetTraining, Reset Training Data
Gui, Add, Button, ys GGuiPreferencesOk Default w100,&OK
Gui, Add, Button, ys GGuiPreferencesCancel w100,&Cancel

;System Tray Icon
Menu, tray, NoStandard
Menu, tray, Add, Open,GuiCloseInactiveTasks
Menu, tray, Add, Preferences,GuiPreferences
Menu, tray, Add,
Menu, tray, Standard
Menu, tray, Default,Open

;add all running tasks
WinGet, id, list,,,%ExcludedTitlesRegEx%
idlist =
Loop, %id%
{
		ActiveIdNew := id%A_Index%
		WinGetTitle, TitleNew, ahk_id %ActiveIdNew%
		IfNotEqual, TitleNew,
			Log=%A_Now%~%TitleNew%~%ActiveIdNew%`n%Log% ; add previous task to list
}
GoSub, SetHotKeys
SetTimer, TimerEvent, %TimerInterval%
Gosub, Wait



CalcExpiryTime:
	ExpiryTime := Ceil(TotalClosedSeconds / TotalClosedTasks)
return

ExcludeProcessPerm:
	;exclude task for always
	WinGet, TaskProcessName, ProcessName, ahk_id %RowText%
	ExcludedProcessesPerm=%ExcludedProcessesPerm%%TaskProcessName%|
	GoSub, WriteIni
	GoSub, GuiCloseInactiveTasks
return

ExcludeProcessTemp:
	;exclude task for this session (doesn't save)
	WinGet, TaskProcessName, ProcessName, ahk_id %RowText%
	ExcludedProcessesTemp=%ExcludedProcessesTemp%%TaskProcessName%|
	GoSub, WriteIni
	GoSub, GuiCloseInactiveTasks
return

ExcludeTitlePerm:
	;exclude task for always
	WinGetTitle, TaskTitleName,ahk_id %RowText%
	InputBox, UserInput, Enter Window Title, Please enter part of the Window Title you want to match against. Enter part of the title to match against more windows`n`nExample:`nMozilla Firefox, ,,,,,,,%TaskTitleName%
	if NOT ErrorLevel
	{
		ExcludedTitlesPerm=%ExcludedTitlesPerm%%UserInput%|
		GoSub, WriteIni
	}
	GoSub, GuiCloseInactiveTasks
return

ExcludeTitleTemp:
	;exclude task for this session (doesn't save)
	WinGetTitle, TaskTitleName,ahk_id %RowText%
	InputBox, UserInput, Enter Window Title, Please enter part of the Window Title you want to match against. Enter part of the title to match against more windows`n`nExample:`nMozilla Firefox, ,,,,,,,%TaskTitleName%
	if NOT ErrorLevel
	{
		ExcludedTitlesTemp=%ExcludedTitlesTemp%%UserInput%|
		GoSub, WriteIni
	}
	GoSub, GuiCloseInactiveTasks
return

RemoveExclusion:
	;remove process from any exclusion list
	WinGet, TaskProcessName, ProcessName, ahk_id %RowText%
	WinGetTitle, TaskTitleName,ahk_id %RowText%
	StringReplace, ExcludedProcessesTemp, ExcludedProcessesTemp, %TaskProcessName%|     ; and remove it from the list
	StringReplace, ExcludedProcessesPerm, ExcludedProcessesPerm, %TaskProcessName%|     ; and remove it from the list
	StringReplace, ExcludedTitlesTemp, ExcludedTitlesTemp, %TaskTitleName%|     ; and remove it from the list
	StringReplace, ExcludedTitlesPerm, ExcludedTitlesPerm, %TaskTitleName%|     ; and remove it from the list
	GoSub, WriteIni
	GoSub, GuiCloseInactiveTasks
return

SwitchTo:
	WinHide, A
	WinActivate, ahk_id %RowText%
return

TaskInfo:
	WinGet, TaskProcessName, ProcessName, ahk_id %RowText%
	WinGetTitle, TaskTitle, ahk_id %RowText%
	WinGet, TaskID, ID, ahk_id %RowText%
	WinGet, TaskPID, PID, ahk_id %RowText%
	Msgbox, Process: %A_TAB%%TaskProcessName% `nTitle: %A_TAB%%TaskTitle% `nID: %A_TAB%%TaskID% `nPID: %A_TAB%%TaskPID%
return

BringToFront:
	ActiveWinId := WinActive(A)
	WinSet, AlwaysOnTop,On, ahk_id %RowText%
	WinSet, AlwaysOnTop,Off, ahk_id %RowText%
	WinActivate, ahk_id %ActiveWinId%
return

SendToBack:
	WinSet, Bottom,, ahk_id %RowText%
return

MinimizeTask:
	WinMinimize, ahk_id %RowText%
	GoSub, GuiCloseInactiveTasks
return

MaximizeTask:
	WinMaximize, ahk_id %RowText%
	GoSub, GuiCloseInactiveTasks
return

ExitTask:
	WinClose, ahk_id %RowText%
	
	LV_GetText(CheckedItemTitle, LastRightClicked,1)
	LV_GetText(CheckedItemId, LastRightClicked,2)
	LV_GetText(CheckedItemTimeLastActive, LastRightClicked,3)
		
	TotalClosedTasks++
		
	; get amount of seconds inactive for task to close
	Loop, Parse, CheckedItemTimeLastActive, %A_Space%
	{
		TotalClosedSeconds += %A_LoopField%
		TotalClosedTasks++
		break
	}
	WinClose, ahk_id %CheckedItemId%
	GoSub, GuiCloseInactiveTasks
return

MenuHide:
	WinHide, A
return

MenuHideExcluded:
	If HideExcludedProcesses = 1
	{
		Menu,ViewMenu,UnCheck,&Hide Excluded Processes
		HideExcludedProcesses = 0
	}
	Else
	{
		Menu,ViewMenu,Check,&Hide Excluded Processes
		HideExcludedProcesses = 1
	}
	GoSub, WriteIni
	GoSub, GuiCloseInactiveTasks
return

MenuAlwaysOnTop:
	If AlwaysOnTop = 1
	{
		Menu,ViewMenu,UnCheck,Always on &Top
		WinSet, AlwaysOnTop, Off, A
		AlwaysOnTop = 0
	}
	Else
	{
		Menu,ViewMenu,Check,Always on &Top
		WinSet, AlwaysOnTop, On, A
		AlwaysOnTop = 1
	}
	GoSub, WriteIni
	
return


MenuStats:
	tExpiryTime := Ceil(TotalClosedSeconds / TotalClosedTasks) 
	StatTasksClosed := TotalClosedTasks - 20
	Msgbox,Total Tasks Closed: %A_Tab%%StatTasksClosed%`nExpiryTime: %A_Tab%%tExpiryTime% seconds `n
return

MenuGuiPreferences:
	Gui,Destroy
	Gosub, GuiPreferences
	Gosub, GuiCloseInactiveTasks
return

GuiPreferences:
	Hotkey,%HotKey1%,Off
  Gui, 2:Default
	Gui, Show, AutoSize Center, %AppTitle% Preferences
	GroupAdd, AppId,%AppTitle%
return

GuiPreferencesResetTraining:
	Gui, Submit, NoHide
	TotalClosedTasks = 20
	TotalClosedSeconds = 7200
	GoSub,WriteIni
	msgbox, Training Data Reset. Expiry time reset to 3 minutes.
return

GuiPreferencesOk:
	Gui,Submit
	If RunAtStartup = 1
		RegWrite, REG_SZ, HKEY_CURRENT_USER, Software\Microsoft\Windows\CurrentVersion\Run, JustCloseSomeTasks, "%A_ScriptFullPath%"
	else
		RegDelete, HKEY_CURRENT_USER, Software\Microsoft\Windows\CurrentVersion\Run, JustCloseSomeTasks
	TotalClosedSeconds := TotalClosedTasks * ExpiryTime
	
	GoSub,SetHotKeys
	GoSub, WriteIni
return

WriteIni:
	IniWrite, %HotKey1%, %IniFile%, Main, Hotkey1 
	IniWrite, %RunAtStartup%, %IniFile%, Main, RunAtStartup
	IniWrite, %AlwaysOnTop%, %IniFile%, Main, AlwaysOnTop
	IniWrite, %HideExcludedProcesses%, %IniFile%, Whitelist, HideExcludedProcesses
	IniWrite, %ExcludedProcessesPerm%, %IniFile%, Whitelist, ExcludedProcessesPerm
	IniWrite, %ExcludedTitlesPerm%, %IniFile%, Whitelist, ExcludedTitlesPerm
	IniWrite, %TotalClosedTasks%, %IniFile%, Stats, TotalClosedTasks
	IniWrite, %TotalClosedSeconds%, %IniFile%, Stats, TotalClosedSeconds
	
return

GuiPreferencesCancel:
	GoSub,SetHotKeys
	Gui,Destroy
return

SetHotKeys:
	Hotkey, IfWinActive,
	if HotKey1
		Hotkey,%Hotkey1%,GuiCloseInactiveTasks, ON
return

TimerEvent:
	WinGetTitle, TitleNew, A

	IfEqual,TitleNew, ;skip empty title
		return
	WinGet, ActiveIdNew, ID, A
	IfEqual,ActiveIdNew, ;skip empty id
		return
		
	; add current window to start of windowlist (new to old)
	; from windowlist add each window to new list if its not yet been added
		
	Log=%A_Now%~%TitleNew%~%ActiveIdNew%`n%Log% ; add previous task to list
return

GuiCloseInactiveTasks:
	SetTimer, TimerEvent, Off
	Gui, 1:Default


	; add all currently active windows
	WinGet, id, list,,,%ExcludedTitlesRegEx%
	idlist =
	Loop, %id%
	{
			this_id := id%A_Index%
			IdList =%IdList%%this_id%`n
	}
	

	GuiControl, -Redraw, MyListView ; for performance reasons
	LV_Delete()
	WinGet, script_id, ID, %AppTitle%
	
	TotalItems = 0
	
	; detmine total active windows
	Loop, Parse,Log,`n
		TotalItems += 1
	
	
	LogProcessed=
	DisplayedTasks = 0
	Loop, Parse,Log,`n
	{
		StringSplit, TaskArray, A_LoopField,~

		;Don't show last active window
		if A_Index>=%TotalItems%
			continue
			
		IfEqual,A_LoopField, ;skip empty lines
			continue
		
			

		IfNotInString, LogProcessed,%TaskArray3%
		{
			IfEqual,TaskArray3,%script_id%
				continue
			IfInString, IdList, %TaskArray3%
			{	
				LogProcessed=%LogProcessed%%A_LoopField%`n
				WinGet, LoopProcessName, ProcessName, ahk_id %TaskArray3%	
				If HideExcludedProcesses = 1
				{
					IfInString,ExcludedProcessesPerm,%LoopProcessName%
						continue
					IfInString,ExcludedProcessesTemp,%LoopProcessName%
						continue
					IfInString,ExcludedTitlesPerm,%TaskArray2%
						continue
					IfInString,ExcludedTitlesTemp,%TaskArray2%
						continue
						
				}
				TimeLastActive :=TaskArray1
				EnvSub, TimeLastActive, %A_Now%,Seconds
				TimeLastActive *=-1

				If TimeLastActive >= 0
				{
					DisplayedTasks++					
					IfInString,ExcludedProcessesPerm,%LoopProcessName%
						LV_Add("", TaskArray2,TaskArray3,"Excluded Process (P)")
					Else IfInString,ExcludedProcessesTemp,%LoopProcessName%
						LV_Add("", TaskArray2,TaskArray3,"Excluded Process (S)")
					Else IfInString,ExcludedTitlesPerm,%TaskArray2%
						LV_Add("", TaskArray2,TaskArray3,"Excluded Title (P)")
					Else IfInString,ExcludedTitlesTemp,%TaskArray2%
						LV_Add("", TaskArray2,TaskArray3,"Excluded Title (S)")
					Else
					{
					If TimeLastActive>%ExpiryTime% ; if task is expired
						LV_Add("Check", TaskArray2,TaskArray3,TimeLastActive " second(s) ago")
					else
						LV_Add("", TaskArray2,TaskArray3,TimeLastActive " second(s) ago")
					}
					}
			}
		}
	}
	LV_ModifyCol()  ; Auto-size each column to fit its contents.
	LV_ModifyCol(1,500) ; limit size first col
	LV_ModifyCol(2,10) ;'hide' ids
	
	GuiControl, +Redraw, MyListView
	
	If AlwaysOnTop = 1
		Gui, +AlwaysOnTop
	Else
		Gui, -AlwaysOnTop
	
	Gui, Show, AutoSize Center, %AppTitle%
	GroupAdd, AppId,%AppTitle%
	GoSub, CalcExpiryTime
	GuiControl,, ExpiryText, Tasks inactive for over %ExpiryTime% Seconds are checked

	SetTimer, TimerEvent, On
return

GuiSize: 
	if A_EventInfo = 1  ; The window has been minimized.  No action needed.
	{
	  return
	}
	Anchor("MyListView", "wh")
	Anchor("ExpiryText","y")
	Anchor("Submit","y")
return

MenuHomepage:
Url = http://justice.dcmembers.com
	msgbox,4,Visit %AppTitle%'s Homepage,Information about this and other projects can be found on Justice's DcMembers page. Do you want to load the following webpage?`n`n%Url%
	IfMsgBox Yes
    Run, %url%
return

#IfWinActive, ahk_group AppId
F1::
MenuAbout:
run, readme.txt
return

CheckForUpdates:
Run, dcuhelper.exe -ri "%AppTitle%" .. "Attention",%A_ScriptDir%\dcuhelper,Hide
return



MenuOnline:
	SupportUrl = http://www.donationcoder.com/Forums/bb/index.php?topic=16018.0
	msgbox,4,Visit Online Support,Support on this application is given via the Donationcoder.com community forums. Do you want to load the following webpage?`n`n%SupportUrl%
	IfMsgBox Yes
    Run, %supporturl%
return

ButtonSubmit:
	Gui Submit, NoHide 
	ClosedCount = 0
	Loop
	{
		RowNumber = 0  ; reset to search from start of list
    RowNumber := LV_GetNext(RowNumber,"C")  ; Resume the search at the row after that found by the previous iteration.
    if not RowNumber  ; The above returned zero, so there are no more selected rows.
        break
		LV_GetText(CheckedItemTitle, RowNumber,1)
    LV_GetText(CheckedItemId, RowNumber,2)
		LV_GetText(CheckedItemTimeLastActive, RowNumber,3)
		
		TotalClosedTasks++
		
		; get amount of seconds inactive for task to close
		Loop, Parse, CheckedItemTimeLastActive, %A_Space%
		{
			TotalClosedSeconds += %A_LoopField%
			TotalClosedTasks++
			break
		}
		
    WinClose, ahk_id %CheckedItemId%
		Sleep,100
		LV_Delete(RowNumber)
		ClosedCount++
	}
	GoSub, CalcExpiryTime
	GuiControl,, ExpiryText, Tasks inactive for over %ExpiryTime% Seconds are checked
	GoSub, WriteIni

	If ClosedCount=0
		WinClose
return

MyListView:
	if A_GuiEvent = RightClick
	{
			LV_GetText(RowText, A_EventInfo,2)  ; Get the text from the row's first field.
			LastRightClicked := A_EventInfo
			if A_EventInfo <> 0 
			{
				WinGet, EventProcessName, ProcessName, ahk_id %RowText%
				IfNotInString,ExcludedProcessesPerm,%EventProcessName%
				{
					IfNotInString,ExcludedProcessesTemp,%EventProcessName%
						Menu,OptionsExclude,Show
					Else
						Menu,OptionsInclude,Show
				}
				Else
					Menu,OptionsInclude,Show
			}
	} 
return

#IfWinActive, ahk_group AppId
!F4::
MenuExit:
	GoSub, WriteIni
	ExitApp
return

OnExit,MenuExit

Wait:
